#include <bits/stdc++.h>

using namespace std;

const int maxn = 4005;
const int mod = 1000000007;

int precalc[maxn][maxn];

int n;
int up_to;

bool bl[maxn][maxn];
int dp[maxn][maxn];

int f(int idx, int last)
{
    if (idx == n)
    {
        return 1;
    }

    if (bl[idx][last] == true)
    {
        return dp[idx][last];
    }

    bl[idx][last] = true;

    int result = 0;

    for (int i = 1; i <= up_to; ++i)
    {
        if (precalc[last][i] < last)
        {
            result += f(idx + 1, precalc[last][i]);

            if (result >= mod)
            {
                result -= mod;
            }
        }
    }

    return result;
}

int main()
{
    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            precalc[i][j] = __gcd(i, j);
        }
    }

    up_to = n;

    int ans = 0;

    while (n >= 1)
    {
        for (int i = 1; i <= up_to; ++i)
        {
            ans += f(1, i);

            if (ans >= mod)
            {
                ans -= mod;
            }
        }

        --n;
    }

    cout << ans << endl;

    return 0;
}
