#include <bits/stdc++.h>
using namespace std;

const int MAXN=4*1e5+1;
long long N;
long long A[MAXN], B[MAXN];

void read()
{
    cin >> N;

    for(int i=0; i<N; i++)
    {
        A[i]=1;
    }

    for(int i=0; i<N; i++)
    {
        cin >> B[i];

        if(B[i]!=0)
        {
            A[B[i]-1]++;
        }
    }
}

void compute()
{
    for(int i=0; i<N; i++)
    {
        if(B[i]==0)
        {
            long long Max=0;

            for(int j=N-1; j>i; j--)
            {
                Max=max(Max, A[j]);
            }

            if(A[i]>Max)
            {
                continue;
            }
            else
            {
                A[i]=Max+1;
            }
        }
    }
}

bool check()
{
    for(int i=0; i<N; i++)
    {
        if(B[i]!=0)
        {
            if(A[i]>=A[B[i]-1])
            {
                return false;
            }
        }
        else
        {
            for(int j=N-1; j>i; j--)
            {
                if(A[i]<A[j])
                {
                    ///cout << A[i] << " " << A[j] << '\n';
                    return false;
                }
            }
        }
    }

    return true;
}

void do_removing()
{
    while(true)
    {
        long long over=0;

        for(int i=0; i<N; i++)
        {
            while(A[i]>0 && check())
            {
                over++;
                A[i]--;
            }

            A[i]++;
        }

        if(over==N)
        {
            break;
        }
    }
}

void test_output()
{
    for(int i=0; i<N; i++)
    {
        cout << A[i] << " ";
    }
}

void solve()
{
    long long sum=0;

    for(int i=0; i<N; i++)
    {
        sum+=A[i];
    }

    cout << sum << '\n';

    for(int i=0; i<N; i++)
    {
        cout << A[i] << " ";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    compute();
    ///do_removing();
    solve();
    ///test_output();
    return 0;
}

