#include <bits/stdc++.h>
using namespace std;

const int MAXN=4*1e5+1;
int N;
int A[MAXN], B[MAXN];
vector<int> edges[MAXN];

void read()
{
    cin >> N;

    for(int i=1; i<=N; i++)
    {
        A[i]=1;
    }

    for(int i=1; i<=N; i++)
    {
        cin >> B[i];

        if(B[i]==0)
        {
            edges[0].push_back(i);
        }
    }
}

void compute()
{
    while(true)
    {
        bool change=false;

        for(int i=1; i<=N; i++)
        {
            if(B[i]==0)
            {
                int Max=0;

                for(int j=N; j>i; j--)
                {
                    Max=max(Max, A[j]);
                }

                if(A[i]>=Max)
                {
                    continue;
                }
                else
                {
                    ///cout << i << " ";
                    change=true;
                    A[i]=Max;

                    for(int i=0; i<edges[0].size(); i++)
                    {
                        if(A[edges[0][i]]<A[i])
                        {
                            A[edges[0][i]]=A[i];
                        }
                    }
                }
            }
            else
            {
                for(int j=i+1; j<B[i]; j++)
                {
                    if(A[i]<A[j])
                    {
                        change=true;
                        A[i]=A[j];
                    }
                }

                if(A[i]>=A[B[i]])
                {
                    change=true;
                    A[B[i]]=A[i]+1;
                }
            }
        }

        if(!change)
        {
            break;
        }
    }

}

void test_output()
{
    for(int i=1; i<=N; i++)
    {
        cout << A[i] << " ";
    }
}

void solve()
{
    long long sum=0;

    for(int i=1; i<=N; i++)
    {
        sum+=A[i];
    }

    cout << sum << '\n';

    for(int i=1; i<=N; i++)
    {
        cout << A[i] << " ";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    compute();
    ///do_removing();
    solve();
    ///test_output();
    return 0;
}
