#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5 + 10;
int n, q, a[maxn], g[3 * maxn], b[maxn], tree[4 * maxn];

void read(){
    cin >> n >> q;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        b[a[i]] = i;
    }
}

void update(int i, int l, int r, int ql, int qr){
    if(tree[i] && l != r){
        tree[2 * i] = tree[2 * i + 1] = 1;
        tree[i] = 0;
    }
    if(ql > qr)
        return;
    if(l == ql && r == qr)
        tree[i] = 1;
    else{
        int mid = (l + r) / 2;
        update(2 * i, l, mid, ql, min(qr, mid));
        update(2 * i + 1, mid + 1, r, max(mid + 1, ql), qr);
    }
}

int query(int i, int l, int r, int x){
    if(tree[i] && l != r){
        tree[2 * i] = tree[2 * i + 1] = 1;
        tree[i] = 0;
    }
    if(l == r)
        return tree[i];
    int mid = (l + r) / 2;
    if(x <= mid)
        return query(2 * i, l, mid, x);
    else
        return query(2 * i + 1, mid + 1, r, x);
}

void solve(){
    int l = 1, r = n;
    while(q--){
        int t;
        cin >> t;
        if(t == 1){
            int p;
            cin >> p;
            if(p == 1) cout << query(1, 1, n, l);
            else cout << query(1, 1, n, r);
            if(p == 1) l++;
            else r--;
        }
        else if(t == 2){
            int x, y;
            cin >> x >> y;
            update(1, 1, n, b[x], b[y]);
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
