#include <bits/stdc++.h>
using namespace std;

const int maxn = 4e5 + 10;
int n, used[maxn], a[maxn], b[maxn], col[maxn];
vector<int> v[maxn];
void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        v[a[i]].push_back(i);
        b[i] = a[i];
    }
}

void dfs(int ver, int c){
    col[ver] = c;
    for(int nb : v[ver]){
        dfs(nb, c - 1);
    }
}
bool check(int x){
    dfs(0, x + 1);
    for(int i = 1;i <= n;i++){
        if(col[i] <= 0)
            return false;
    }
    return true;
}
void solve(){
    int l = 1, r = n;
    while(l <= r){
        int mid = (l + r) / 2;
        if(check(mid))
            r = mid - 1;
        else
            l = mid + 1;
    }
    check(l);
    long long sum = 0;
    for(int i = 1;i <= n;i++)
        sum += col[i];
    cout << sum << endl;
    for(int i = 1;i <= n;i++){
        cout << col[i] << " ";
    }
    cout << endl;
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
