#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;

int n;

int a[maxn];
int b[maxn];

vector<int> g[maxn];

int preffix[maxn];
int suffix[maxn];

int in_degree[maxn];

long long update[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] != 0)
        {
            ++in_degree[a[i]];
            g[i].push_back(a[i]);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        if (in_degree[i] == 0 && g[i].empty())
        {
            for (int j = 1; j <= n; ++j)
            {
                if (i == j)
                {
                    continue;
                }

                if (j > i)
                {
                    if (a[j] == 0 || a[j] > i)
                    {
                        g[j].push_back(i);
                        ++in_degree[i];
                    }
                }
                else
                {
                    g[i].push_back(j);
                    ++in_degree[j];
                }
            }
        }
    }

    queue<int> q;

    for (int i = 1; i <= n; ++i)
    {
        if (in_degree[i] == 0)
        {
            q.push(i);
            b[i] = 1;
        }
    }

    while (!q.empty())
    {
        int node = q.front();
        q.pop();

        for (auto next_node : g[node])
        {
            --in_degree[next_node];

            if (in_degree[next_node] == 0)
            {
                q.push(next_node);
                b[next_node] = max(b[next_node], 1 + b[node]);
            }
        }
    }

    long long sum = 0;

    for (int i = 1; i <= n; ++i)
    {
        sum += b[i];
    }

    cout << sum << endl;

    for (int i = 1; i <= n; ++i)
    {
        cout << b[i] << " ";
    }

    cout << endl;

    return 0;
}
