#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;

int n;

int a[maxn];
int b[maxn];

vector<int> g[maxn];

int in_degree[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] != 0)
        {
            g[i].push_back(a[i]);
            ++in_degree[a[i]];
        }
    }

    queue<int> q;

    for (int i = 1; i <= n; ++i)
    {
        if (in_degree[i] == 0)
        {
            if (g[i].empty())
            {
                b[i] = -1;
                continue;
            }

            b[i] = 1;

            q.push(i);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] == 0 || b[i] == -1)
        {
            for (int j = i + 1; j <= n; ++j)
            {
                i (a[j] == 0 || b[j] == -1)
                {
                    g[j].push_back(i);
                    ++in_degree[i];
                }
            }
        }
    }

    while (!q.empty())
    {
        int node = q.front();
        q.pop();

        for (auto next_node : g[node])
        {
            --in_degree[next_node];

            if (in_degree[next_node] == 0)
            {
                q.push(next_node);
                b[next_node] = max(b[next_node], 1 + b[node]);
            }
        }
    }

    int curr_max = 1;

    for (int i = n; i >= 1; --i)
    {
        if (b[i] == -1)
        {
            b[i] = curr_max;
        }

        curr_max = max(curr_max, b[i]);
    }

    long long sum = 0;

    for (int i = 1; i <= n; ++i)
    {
        sum += b[i];
    }

    cout << sum << endl;

    for (int i = 1; i <= n; ++i)
    {
        cout << b[i] << " ";
    }

    cout << endl;

    return 0;
}
