#include<bits/stdc++.h>
using namespace std;

#define endl "\n"

const long long MAX_N = 4 * 1e5 + 10;

int n;
int a[MAX_N];
int rk[MAX_N];
bool isUsed[MAX_N];

vector <int> eq;
int maxFromNowOn = 1e9;

void solve (int i, int x) {
    if (x > 10) return;
    if (rk[i] > x) return;
    if (i == 0) return;
    rk[i] = max(x, rk[i]);

    if (rk[i] == maxFromNowOn){
        eq.push_back(i);
    }else if (a[i] == 0 && rk[i] < maxFromNowOn) {
        maxFromNowOn = rk[i];
        eq.resize(0);
        eq.push_back(rk[i]);
    } else if (rk[i] > maxFromNowOn) {
        maxFromNowOn = rk[i];
        for (int j = 0; j < eq.size(); j ++) {
            solve (eq[j], maxFromNowOn);
        }
        eq.push_back(i);
    }

    if (a[i] != 0) {
        solve (a[i], rk[i] + 1);
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
        if(a[i] != 0) isUsed[a[i]] = true;
    }

    for (int i = 1; i <= n; i ++) {
        if(!isUsed[i]) rk[i] = 1;
    }
    for (int i = 1; i <= n; i ++) {
        solve (a[i], rk[i] + 1);
    }
    long long sum = 0;
    for (int i = 1; i <= n; i ++) {
        sum += rk[i];
    }
    cout << sum << endl;
    for (int i = 1; i <= n; i ++) {
        cout << rk[i] << " ";
    }
    cout << endl;


    return 0;
}

