# include <iostream>
# include <queue>
# include <vector>
using namespace std;

const long long MAX=4*1e5+1;
long long b[MAX];
vector<long long> a[MAX];
long long edges[MAX];
vector<long long> curr;
long long id=0;
long long n;
long long ans[MAX];
vector<pair<long long,long long>> big;
long long maxi=0;

void topo()
{
    queue<long long> q;
    for(long long i=id; i<curr.size(); i++)
    {
        //cout<<curr[i]<<" ";
        if(edges[curr[i]]==0)
        {
            q.push(curr[i]);
            ans[curr[i]]=1;
        }
    }
    //cout<<endl;

    id=curr.size();
    while(q.size()>0)
    {
        long long p=q.front();
        q.pop();

        maxi=max(maxi,ans[p]);
        for(auto next: a[p])
        {
            edges[next]--;
            if(edges[next]==0)
            {
                if(b[next]!=0) ans[next]=ans[p]+1;
                q.push(next);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(long long i=1; i<=n; i++)
    {
        cin>>b[i];
    }

    for(long long i=1; i<=n; i++)
    {
        if(b[i]!=0)
        {
            curr.push_back(i);
            a[i].push_back(b[i]);
            edges[b[i]]++;
        }
        else
        {
            maxi=0;
            topo();
            big.push_back({i,maxi+1});
        }
    }

    maxi=1;
    for(long long i=big.size()-1;i>=0;i--)
    {
        maxi=max(big[i].second,maxi);
        ans[big[i].first]=maxi;
    }

    long long sum=0;
    for(long long i=1;i<=n;i++)
    {
        sum=sum+ans[i];
    }

    cout<<sum<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<ans[i]<<" ";
    }
    cout<<endl;
    return 0;
}
