#include <bits/stdc++.h>

using namespace std;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x = xi;
        y = yi;
    }
};

const int maxn = 4*1e5+5;

int n,used[maxn],otg[maxn];
vector<Point>v[maxn];
int ans[maxn],b[maxn];
vector<int>g[maxn];
long long sum;
bool f;

void read()
{
    cin >> n;
    f = false;
    if(n<=1e5) f = true;
    int a,gr;
    for(int i=1;i<=n;i++)
    {
        cin >> a;
        if(f)
        {
            gr = a;
            if(gr==0) gr = n+1;
            v[a].push_back({i,1});
            for(int j=i+1;j<gr;j++)
            {
                v[i].push_back({j,0});
            }
        }
        else
        {
            g[a].push_back(i);
            b[i] = a;
        }
    }
}

void dfs(int beg)
{
    int sz = v[beg].size();
    used[beg] = 1;
    Point nb;
    if(sz==0)
    {
        otg[beg] = 1;
        //if(beg) sum++;
        return;
    }
    int ch = 0;
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(!used[nb.x]) dfs(nb.x);
        if(nb.y==1) ch = max(ch,otg[nb.x]+1);
        else ch = max(ch,otg[nb.x]);
    }
    otg[beg] = ch;
    //if(beg) sum += ans[beg];
}

void dfs2(int beg)
{
    int nb, sz = g[beg].size();
    if(sz==0)
    {
        ans[beg] = 1;
        //if(beg) sum++;
        return;
    }
    int ch = 0;
    for(int i=0;i<sz;i++)
    {
        nb = g[beg][i];
        dfs2(nb);
        ch = max(ch,ans[nb]);
    }
    ans[beg] = ch+1;
    //if(beg) sum += ans[beg];
}
void solve1()
{
    dfs(0);
    for(int i=1;i<=n;i++)
    {
        sum += otg[i];
    }
    cout << sum << endl;
    for(int i=1;i<=n;i++)
    {
        cout << otg[i] << " ";
    }
    cout << endl;
}

void solve2()
{
    dfs2(0);
    int maxch = 0;
    for(int i=n;i>=1;i--)
    {
        maxch = max(maxch,ans[i]);
        if(b[i]==0) ans[i] = maxch;
    }
    for(int i=1;i<=n;i++)
    {
        sum += ans[i];
    }
    cout << sum << endl;
    for(int i=1;i<=n;i++)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
}

void solve()
{
    if(f) solve1();
    else solve2();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
