#include <bits/stdc++.h>
using namespace std;

const int maxn = 4e5 + 10;
int n, used[maxn], a[maxn], b[maxn], col[maxn];
vector<int> v[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        v[a[i]].push_back(i);
    }
}

bool check(int x){
    b[n] = x;
    for(int i = n;i >= 1;i--){
        if(a[i] == 0 && i != n)
            b[i] = 1e9;
        for(int j = 1;j < i;j++){
            if(a[j] == i)
                b[j] = b[i] - 1;
        }
    }
    for(int i = 1;i <= n;i++){
        if(b[i] <= 0)
            return false;
    }
    return true;
}
void dfs(int ver, int c){
    col[ver] = c;
    for(int nb : v[ver]){
        dfs(nb, c - 1);
    }
}
bool check2(int x){
    dfs(0, x + 1);
    for(int i = 1;i <= n;i++){
        if(col[i] <= 0)
            return false;
    }
    return true;
}
void solve(){
    if(n <= 1000){
        int l = 1, r = n;
        while(l <= r){
            int mid = (l + r) / 2;
            if(check(mid))
                r = mid - 1;
            else
                l = mid + 1;
        }
        check(l);
        b[1] = 1;
        for(int i = 1;i <= n;i++){
            if(b[i] > n)
                b[i] = 1;
            if(b[a[i]] > n)
                b[a[i]] = 1;
            b[a[i]] = max(b[a[i]], b[i] + 1);
        }
        int mx = 0;
        for(int i = n;i >= 1;i--){
            if(a[i] == 0){
                mx = max(mx, b[i]);
                b[i] = mx;
            }
        }
        long long sum = 0;
        for(int i = 1;i <= n;i++){
            sum += b[i];
        }
        cout << sum << endl;
        for(int i = 1;i <= n;i++){
            cout << b[i] << ' ';
        }
        cout << endl;
    }
    else{

        int l = 1, r = n;
        while(l <= r){
            int mid = (l + r) / 2;
            if(check2(mid))
                r = mid - 1;
            else
                l = mid + 1;
        }
        check(l);
        long long sum = 0;
        for(int i = 1;i <= n;i++)
            sum += col[i];
        cout << sum << endl;
        for(int i = 1;i <= n;i++){
            cout << col[i] << " ";
        }
        cout << endl;

    }
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
