#include <bits/stdc++.h>
using namespace std;

const int maxn = 4e5 + 10;
int n, used[maxn], a[maxn], b[maxn], nxt[maxn];

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        nxt[i] = a[i];
    }
}

bool check(int x){
    b[0] = x + 1;
    for(int i = n;i >= 1;i--){
        b[i] = b[a[i]] - 1;
    }
    for(int i = 1;i <= n;i++){
        if(b[i] <= 0)
            return false;
    }
    return true;
}
void solve(){
    int l = 1, r = n;
    while(l <= r){
        int mid = (l + r) / 2;
        if(check(mid))
            r = mid - 1;
        else
            l = mid + 1;
    }
    check(l);
    for(int i = 1;i <= n;i++){
        if(!used[i]){
            if(a[i] == 0) continue;
            int p = i, cnt = 1;
            while(a[p] != 0){
                b[p] = cnt;
                used[p] = 1;
                cnt++;
                p = nxt[p];
            }
            used[p] = 1;
        }
    }
    long long sum = 0;
    for(int i = 1;i <= n;i++){
        sum += b[i];
    }
    cout << sum << endl;
    for(int i = 1;i <= n;i++){
        cout << b[i] << ' ';
    }
    cout << endl;
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
